#include <string>
#include <iostream>

#include "sequence.hh"
#include <assert.h>

using namespace std;
    


/**
 * initialize the buffer for one row with name <name>
 */

void Sequence::init_buffer(const string &name) {
  rows_=1;
  seq_.resize(0);
  names_.resize(0);
  names_.push_back(name);
}

/**
 * initialize the buffer for the rows in <seq> with the names from seq
 */
void Sequence::init_buffer(const Sequence &seq) {
  names_ = seq.names_;
  rows_ = seq.rows_;
  seq_.resize(0);
}
  
void Sequence::append_row(string name, string seqstr) {
  names_.push_back(name);
    
  if (rows_==0) {
    int len=seqstr.length();
    seq_.resize(len);
  }
  
  for (int i=1; i<=seq_.size(); i++) {
	  (*this)[i].push_back(seqstr[i-1]);
  }
  
  rows_++;
}


void Sequence::operator += (Sequence s) {
    for (int i=0; i<s.length(); i++)
		seq_.push_back( s[i] );
}

void Sequence::operator += (AliColumn c) {
    seq_.push_back(c);
}

void Sequence::operator += (char c) {
	int old_size=seq_.size();
    seq_.resize(old_size+1);
    for (int i=0; i<rows_; i++) {
		(*this)[old_size+1].push_back(c);
    }
}

void Sequence::write(ostream &out, int start, int end) const {
    // write from position start to position end to out
    // prefix output by names
    
    for (int i=0; i<rows_; i++) {
		int ow=out.width(18);
		out << left << names_[i]<<" ";
		out.width(ow);
		
		for (int j=start; j<=end; j++) {
			out << seq_[j-1][i];
		}
		out <<endl;
    }
}

void Sequence::write(ostream &out) const {
    write(out,1,seq_.size());
}
